import QtQuick 2.0
import "board.js" as Board

//This object manages the actions of the artificial intelligence
Timer{

    onTriggered: computerPlay();

    function computerPlay() {
        //If the human player is activated skip this function
        if(settingsmanager.getAIPlayer() === false) return

        var game = Board.game;

        //Extract the possible moves from the logic
        var moves = new Board.Checkers.MoveList(game.board.area());
        game.board.fillMoveList(moves);

        //Returns the best move in the given situation
        var result = {};
        if(moves.length > 1) {
            console.log("Computer is thinking...");
            result = game.suggest(settingsmanager.getDifficultyPlayoff(settingsmanager.getDifficulty()));
        } else {
            var move = moves.list[0];
            result.fromRow = move >> 24;
            result.fromCol = (move >> 16) & 0xFF;
            result.toRow = (move >> 8) & 0xFF;
            result.toCol = (move) & 0xFF;
        }

        //Make the move and start the animation
        var winner = game.move(result.fromRow, result.fromCol, result.toRow, result.toCol);
        checkboardui.movePiece(result.fromRow, result.fromCol, result.toRow, result.toCol);

        if(winner){
            checkboardui.gamewon(winner);
        }

        if(game.inMultiTurn()){
            aitimer.interval = 1000;
            aitimer.start();
        }
    }
}
